/*
 * The rsplib Prototype -- An RSerPool Implementation.
 * Copyright (C) 2005-2006 by Thomas Dreibholz, dreibh@exp-math.uni-essen.de
 *
 * $Id: asapinterthreadmessage.h 1087 2006-05-03 08:20:50Z dreibh $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Contact: rsplib-discussion@sctp.de
 *          dreibh@iem.uni-due.de
 *
 */

#ifndef ASAPINTERTHREADMESSAGE_H
#define ASAPINTERTHREADMESSAGE_H

#include "tdtypes.h"
#include "interthreadmessageport.h"
#include "rserpoolmessage.h"


#ifdef __cplusplus
extern "C" {
#endif


struct ASAPInterThreadMessage
{
   struct InterThreadMessageNode Node;
   struct RSerPoolMessage*       Request;
   struct RSerPoolMessage*       Response;
   size_t                        TransmissionTrials;
   unsigned int                  Error;
   bool                          ResponseExpected;
   unsigned long long            ResponseTimeoutTimeStamp;
  
   unsigned long long            CreationTimeStamp;
   unsigned long long            TransmissionTimeStamp;
};


struct ASAPInterThreadMessage* asapInterThreadMessageNew(
                                  struct RSerPoolMessage* request,
                                  const bool              responseExpected);
void asapInterThreadMessageDelete(struct ASAPInterThreadMessage* aitm);


#ifdef __cplusplus
}
#endif

#endif
